import '@nativescript/macos-node-api';
import type { NativeWindow } from './views/window/native-window.js';
import type { Window } from './views/window/window.js';
export declare function setCustomDelegate(customAppDelegate?: any): void;
declare class AppDelegate extends NSObject implements NSApplicationDelegate {
    window?: NativeWindow;
    running: boolean;
    isActive: boolean;
    static windowTitle: string;
    static ObjCProtocols: (typeof NSApplicationDelegate)[];
    static ObjCExposedMethods: {
        openDocs: {
            returns: number;
            params: number[];
        };
        openGithub: {
            returns: number;
            params: number[];
        };
        openDiscord: {
            returns: number;
            params: number[];
        };
    };
    applicationDidFinishLaunching(_notification: NSNotification): void;
    applicationWillTerminate(_notification: NSNotification): void;
    openDocs(_id: this): void;
    openGithub(_id: this): void;
    openDiscord(_id: this): void;
}
export declare function RunLoop(): void;
export declare class Application {
    static delegate: AppDelegate;
    static application: NSApplication;
    static rootView: HTMLViewElement;
    static window: Window;
    static appMenu: NSMenu;
    static ensure60FPS: boolean;
    static launch(): void;
    static createMenu(): void;
}
declare global {
    var NativeScriptApplication: typeof Application;
}
export {};
