var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Layout } from '../../layout/index.js';
import { Color } from '../../style/utils/color.js';
import { native } from '../decorators/native.js';
import { overrides } from '../decorators/overrides.js';
import { view } from '../decorators/view.js';
import { TextBase } from '../text/text-base.js';
import { NativeButton } from './native-button.js';
const TitleProperty = {
    setNative: (view, _key, value) => {
        if (view.nativeView && !view.firstChild) {
            view.nativeView.setTitle(value || '');
        }
    },
    shouldLayout: true,
};
let Button = class Button extends TextBase {
    constructor() {
        super(...arguments);
        this.supportedNodeTypes = [Node.TEXT_NODE];
    }
    get isLeaf() {
        return true;
    }
    initNativeView() {
        this.nativeView = NativeButton.initWithOwner(new WeakRef(this));
        return this.nativeView;
    }
    prepareNativeView(nativeView) {
        nativeView.target = this.nativeView;
        nativeView.action = 'clicked';
        nativeView.bezelStyle = NSBezelStyle.Automatic;
    }
    updateTextContent() {
        if (this.nativeView && this.firstChild) {
            this.nativeView.setTitle(this.textContent || '');
            Layout.computeAndLayout(this);
        }
    }
    setColor(key, value, config) {
        const nativeValue = config.converter?.toNative?.(key, value);
        if (nativeValue && this.nativeView) {
            this.nativeView.setTitleColor(nativeValue);
        }
    }
    setBackgroundColor(_key, value, _config) {
        if (this.nativeView) {
            const nativeValue = !value ? undefined : new Color(value).toNSColor();
            this.nativeView.bezelColor = nativeValue || NSColor.lightGrayColor;
            if (this.nativeView.bezelStyle === NSBezelStyle.TexturedSquare || this.nativeView.bezelStyle === NSBezelStyle.Rounded) {
                this.nativeView.wantsLayer = true;
                this.nativeView.layer.backgroundColor = nativeValue?.CGColor;
            }
        }
    }
    onMeasureFunction(width, widthMode, height, heightMode) {
        return super.onMeasureFunction(width, widthMode, height, heightMode);
    }
    applyLayout(parentLayout) {
        super.applyLayout(parentLayout);
        if (this.nativeView) {
            this.nativeView.translatesAutoresizingMaskIntoConstraints = true;
        }
    }
};
__decorate([
    native(TitleProperty),
    __metadata("design:type", String)
], Button.prototype, "title", void 0);
__decorate([
    overrides('color'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, Object]),
    __metadata("design:returntype", void 0)
], Button.prototype, "setColor", null);
__decorate([
    overrides('backgroundColor'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, Object]),
    __metadata("design:returntype", void 0)
], Button.prototype, "setBackgroundColor", null);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.bezelStyle = value;
            }
        },
    }),
    __metadata("design:type", Number)
], Button.prototype, "bezelStyle", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.setButtonType(value);
            }
        },
    }),
    __metadata("design:type", Number)
], Button.prototype, "buttonType", void 0);
Button = __decorate([
    view({
        name: 'HTMLButtonElement',
        tagName: 'button',
    })
], Button);
export { Button };
//# sourceMappingURL=button.js.map