var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var NSSliderAutoResizable_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { View } from '../view/view.js';
export class SliderChangeEvent extends Event {
    constructor(value, eventDict) {
        super('sliderChanged', eventDict);
        this.value = value;
    }
}
let NSSliderAutoResizable = NSSliderAutoResizable_1 = class NSSliderAutoResizable extends NSSlider {
    static initWithOwner(owner) {
        const slider = NSSliderAutoResizable_1.new();
        slider._owner = owner;
        return slider;
    }
    sliderChanged(_id) {
        const owner = this._owner.deref();
        if (owner) {
            owner.dispatchEvent(new SliderChangeEvent(owner.nativeView?.doubleValue || 0));
        }
    }
};
NSSliderAutoResizable.ObjCExposedMethods = {
    sliderChanged: { returns: interop.types.void, params: [interop.types.id] },
};
NSSliderAutoResizable = NSSliderAutoResizable_1 = __decorate([
    NativeClass
], NSSliderAutoResizable);
export { NSSliderAutoResizable };
let Slider = class Slider extends View {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
    }
    get isLeaf() {
        return true;
    }
    initNativeView() {
        this.nativeView = NSSliderAutoResizable.initWithOwner(new WeakRef(this));
        this.nativeView.action = 'sliderChanged';
        this.nativeView.target = this.nativeView;
        return this.nativeView;
    }
};
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.numberOfTickMarks = value;
            }
        },
    }),
    __metadata("design:type", Number)
], Slider.prototype, "numberOfTickMarks", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.allowsTickMarkValuesOnly = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], Slider.prototype, "allowsTickMarkValuesOnly", void 0);
Slider = __decorate([
    view({
        name: 'HTMLSliderElement',
        tagName: 'slider',
    })
], Slider);
export { Slider };
//# sourceMappingURL=slider.js.map