var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import '@nativescript/macos-node-api';
let SplitViewController = class SplitViewController extends NSSplitViewController {
    viewDidLayout() {
        super.viewDidLayout();
        this?.resizeSubViews();
    }
    animatePresentationOfViewControllerFromViewController(viewController, fromViewController) {
        fromViewController.view.addSubview(viewController.view);
        viewController.view.alphaValue = 1.0;
        viewController.view.frame = fromViewController.view.frame;
        viewController.view.autoresizesSubviews = true;
        this.resizeSubViews();
    }
    animateDismissalOfViewControllerFromViewController(viewController, _fromViewController) {
        // Animate to the final state
        viewController.view.animator().alphaValue = 0.0;
        viewController.view.removeFromSuperview();
    }
    splitViewDidResizeSubviews(_notification) {
        this?.resizeSubViews();
    }
    resizeSubViews() {
        const owner = this._owner?.deref();
        let child = owner?.firstChild;
        while (child) {
            child.adjustSize();
            child = child.nextSibling;
        }
    }
};
SplitViewController.ObjCProtocols = [NSSplitViewDelegate, NSViewControllerPresentationAnimator];
SplitViewController = __decorate([
    NativeClass
], SplitViewController);
export { SplitViewController };
//# sourceMappingURL=split-view-controller.js.map