import { FlexStyle } from '../../layout/index.js';
import type { StylePropertyConfig } from '../../style/index.js';
import { ViewBase } from '../view/view-base.js';
export declare class SplitViewItem extends ViewBase {
    nativeView?: NSView;
    splitViewItem?: NSSplitViewItem;
    /**
     * This is the root of flexbox layout.
     */
    isRoot: boolean;
    initNativeView(): NSView;
    adjustSize(): void;
    setWidth(key: string, value: FlexStyle['width'], config: StylePropertyConfig): void;
    setHeight(key: string, value: FlexStyle['height'], config: StylePropertyConfig): void;
    setMinWidth(_key: string, value: FlexStyle['minWidth'], _config: StylePropertyConfig): void;
    setMaxWidth(_key: string, value: FlexStyle['maxWidth'], _config: StylePropertyConfig): void;
    setMinHeight(_key: string, value: FlexStyle['minHeight'], _config: StylePropertyConfig): void;
    setMaxHeight(_key: string, value: FlexStyle['maxHeight'], _config: StylePropertyConfig): void;
    getValue(type: 'width' | 'height', value: FlexStyle['width']): number;
    getParentDimension(type: 'width' | 'height'): number;
}
