import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { ToolbarItem } from './toolbar-item.js';
import type { ViewBase } from '../view/view-base.js';
export declare class ToolbarGroupSelectedEvent extends Event {
    selectedIndex: number;
    constructor(selectedIndex: number, eventDict?: EventInit);
}
export type ToolbarGroupSelectionMode = 'selectOne' | 'selectAny' | 'momentary';
export declare class ToolbarGroup extends ToolbarItem {
    nativeView?: NSToolbarItemGroup;
    private target?;
    private items;
    initNativeView(): NSToolbarItemGroup | undefined;
    disposeNativeView(): void;
    addNativeChild(child: ViewBase): void;
    removeNativeChild(child: any): void;
    selectedIndex: number;
    selectionMode: ToolbarGroupSelectionMode;
    titles: string[];
}
